﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Chapter2
{
    public struct ErrorMessage
    {
        private int errCode;
        private int details;
        private string msg;

        // details elided
    }

    class BaseType : ICloneable
    {
        private string label = "class name";
        private int[] values = new int[10];

        public object Clone()
        {
            BaseType rVal = new BaseType();
            rVal.label = label;
            for (int i = 0; i < values.Length; i++)
                rVal.values[i] = values[i];
            return rVal;
        }
    }

    class Derived : BaseType
    {
        private double[] dValues = new double[10];

        static void Mains(string[] args)
        {
            Derived d = new Derived();
            Derived d2 = d.Clone() as Derived;

            if (d2 == null)
                Console.WriteLine("null");
        }
    }


    public class Item24
    {
        public static void Tests()
        {

        }
    }

    namespace Sample3
    {
        class BaseType
        {
            private string label;
            private int[] values;

            protected BaseType()
            {
                label = "class name";
                values = new int[10];
            }

            // Used by devived values to clone
            protected BaseType(BaseType right)
            {
                label = right.label;
                values = right.values.Clone() as int[];
            }
        }

        sealed class Derived : BaseType, ICloneable
        {
            private double[] dValues = new double[10];

            public Derived()
            {
                dValues = new double[10];
            }

            // Construct a copy
            // using the base class copy ctor
            private Derived(Derived right) :
                base(right)
            {
                dValues = right.dValues.Clone()
                  as double[];
            }

            public object Clone()
            {
                Derived rVal = new Derived(this);
                return rVal;
            }
        }

    }
}
