﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace Chapter3
{
    public class LockingExample
    {
        public void MyMethod()
        {
            lock (this)
            {
                // elided
            }
        }
        // elided

        private int total;

        [MethodImpl(MethodImplOptions.Synchronized)]
        public void IncrementTotal()
        {
            total++;
        }
    }

    public class SampleTwo
    {
        private object syncHandle = new object();

        public void IncrementTotal()
        {
            lock (syncHandle)
            {
                // code elided
            }
        }

    }

    public class SampleThree
    {
        private object syncHandle;

        private object GetSyncHandle()
        {
            System.Threading.Interlocked.CompareExchange(
                ref syncHandle, new object(), null);
            return syncHandle;
        }

        public void AnotherMethod()
        {
            lock (GetSyncHandle())
            {
                // ... code elided
            }
        }

        public void YetAnotherMethod()
        {
            DoStuffThatIsNotSynchronized();
            int val = RetrieveValue();
            lock (GetSyncHandle())
            {
                // ... code elided
            }
            DoSomeFinalStuff();
        }

        private void DoSomeFinalStuff()
        {
            throw new NotImplementedException();
        }

        private int RetrieveValue()
        {
            throw new NotImplementedException();
        }

        private void DoStuffThatIsNotSynchronized()
        {
            throw new NotImplementedException();
        }
    }


    public class Item31
    {
        public static void Tests()
        {
            LockingExample x = new LockingExample();
            lock (x)
                x.MyMethod();
        }
    }
}
